//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <iostream.h>

#pragma hdrstop

//---------------------------------------------------------------------------
USERES("isocalc.res");
//---------------------------------------------------------------------------
int main(int argc, char **argv)
{
  /*	Generates ALL possible non equivalent isomers of a cyclic consisting of ncyc monomers
      and nmon different types of monomers which can bind in either direction.
      Count number of isomers with targ_c[i] monomers of type i
      Unsymmetrical monomers z->z */
  // initialize
  int ncyc,nmon; // number of monomers in the cyclic, no. of types of monomer
  int cyc[25]; // the make up of the cyclic (monomers)
  unsigned int dir=0; //the direction of the monomers in the cyclic
  int rot_cyc[25]; // rotated cyclic
  unsigned int rot_dir; // rotated direction
  int flip_cyc[25]; // flipped cyclic
  unsigned int flip_dir; // flippped direction
  int totc=0; // count of the number of isomers, total no. of isomers
  bool sym;
  unsigned int temp,temp2; //temporary work variables for direction rotation/flipping
  unsigned int dirmax=1; // dir must be < dirmax
  unsigned int mask; // bit mask for dir
  for (int j=0;j<25;j++) {
  	cyc[j]=0;
  }
  cout << "z->z system\n";
  cout << "Number of monomers in the cyclic? ";
  cin >> ncyc;
  cout << "How many types of monomers? ";
  cin >> nmon;
  if (ncyc==1 || ncyc>24 || nmon>24 || nmon<1) { cout << "\nValues not valid. Try again\n";getch();return 0; }
  cout << "\nWorking...\n";
  for (int j=0; j<ncyc; j++) dirmax*=2;
  mask=dirmax-1;
  int idx;
  bool idmon; //identical monomers on transformation
  do {
  //  cout << "test: ";
    for (int i=0; i<ncyc;i++) {
    	rot_cyc[i]=cyc[i]; // make a copy of the monomers of the cyclic
  //    cout << cyc[i] << ',';
    }
    rot_dir=dir;
  //  cout << "dir " << dir << '\n';
    for (int i=0; i<ncyc; i++) {
      idmon=true;
      sym = false;
      for (int j=ncyc-1; j>=0; j--) {   // check whether this has been counted already
      	if (cyc[j]>rot_cyc[j]) {idmon=false; sym = true; break; }
        else if (cyc[j]<rot_cyc[j]) {idmon=false; sym = false; break; }
      }
      if (idmon) sym = (rot_dir < dir); // if apppropriate check direction
      if (sym) break; //drop out if already counted this

      flip_dir=0;         // flip the direction
      temp2=rot_dir;
      for (int j=0; j<ncyc; j++) {
     		flip_cyc[j]=rot_cyc[ncyc-1-j];
        temp=temp2&1;
        flip_dir<<=1;
        temp2>>=1;
        flip_dir|=temp;
      }
      flip_dir=~flip_dir&mask;
#ifdef debug
      cout << "Rot: ";
      for (int j=0; j<ncyc; j++) cout << rot_cyc[j] << ',';
      cout << '\n';
      cout << "Flip: ";
   		for (int j=0; j<ncyc; j++) cout << flip_cyc[j] << ',';
      cout << '\n' << rot_dir << ' ' << flip_dir << '\n';
      getch();
#endif

      idmon=true;
			for (int j=ncyc-1; j>=0; j--) {   // check whether this has been counted already
      	if (cyc[j]>flip_cyc[j]) {idmon=false; sym = true; break; }
        else if (cyc[j]<flip_cyc[j]) {idmon=false; sym = false; break; }
      }
      if (idmon) sym = (flip_dir < dir); // if apppropriate check direction
      if (sym) break; //drop out if already counted this

      rot_cyc[ncyc]=rot_cyc[0]; // rotate the monomers
      for (int j=0; j<ncyc; j++) rot_cyc[j]=rot_cyc[j+1]; // be careful not to overrun array!
      temp = rot_dir & 1; // rotate the directions
      rot_dir >>= 1;
      temp <<= ncyc-1;
      rot_dir|=temp;

    }

    if (!sym) {
      totc++;
     //cout << dir << '\n';
#ifdef debug
      cout << "Count ";
      for (int j=0; j<ncyc; j++) {
      	cout << cyc[j] << ',';
      }
      cout << '\n' << dir << '\n';
      getch();
#endif
    }
    // now increment the cyclic
    idx=0;
    dir++;
    if (dir==dirmax) {
    	dir=0;
    	while (idx<ncyc) {
    		cyc[idx]++;
      	if (cyc[idx]==nmon) {
      		cyc[idx]=0;
        	idx++;
      	}
      	else break;
    	}
    }
  } while (idx<ncyc);
  cout << "Total number of isomers: " << totc << '\n';
  cout << "Press any key to end.";
  getch();
	return 0;
}
//---------------------------------------------------------------------------
