//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <iostream.h>
#pragma hdrstop
//---------------------------------------------------------------------------
USERES("seqiso.res");
//---------------------------------------------------------------------------
// J.E.Redman 1999
// Find the number of sequence isomers in a directional cyclic with v vertices
// and c different types of monomer
// where cc[i] is the number of times monomer i is in the cyclic
// Using Plya's theorem.

int fact(int n)   //returns factorial of n
{
  int f=1;
	for (int i=1;i<=n;i++) f*=i;
  return f;
}

int main(int argc, char **argv)
{
  cout << "Calculates number of sequence isomers by Polya's theorem\n";
  int v; // number of monomers in the cyclic
  int c,tot=0; // the number of different types of monomer
  cout << "Number of monomers in the cyclic? ";
  cin >> v;
  cout << "Number of types of monomer? ";
  cin >> c;
  if (v==0 || v>12 || c>v || c<1) {cout << "Error. Invalid values. Exiting.\n"; getch();return 0;}
  int cc[13]; // an array to hold the chosen numbers of monomers
  for (int i=0;i<c-1;i++) {
  	cout << "No. of monomer "<<i<<" : ";
    cin >> cc[i];
    tot+=cc[i];
  }
  if (tot>v) {cout << "Too many monomers. Exiting";getch();return 0;}
  cc[c-1]=v-tot;
  cout << "No. of monomer " << (c-1) << " : " << cc[c-1] << '\n';
  int coeff[10]; // coefficients of polynomial
  int l[10]; // the cycle length for each rotation and the identity l[0]
  bool term; // true if there is a term in the polynomial expansion which is relevant
  int number=0; // the number of isomers
  l[0]=1; // identity cycle length is always 1
  for (int i=1; i<=v/2; i++) { // work out cycle length
  	for (int j=1;j<=v; j++) {
    	if (!((i*j)%v)) { l[i]=j; break;} // is there a better way of doing this ?
    }
  }
  cout << '\n';
  for (int i=0; i<=v/2; i++) {
    coeff[i]=1;
  	term=true;
  	for (int j=0; j<c; j++) {
    	if (cc[j]%l[i]) term=false;
    }
    if (term) { // if this part of the polynomial contains the term of interest
    	for (int j=0; j<c; j++) {
      	coeff[i]*=fact(cc[j]/l[i]);
       }
    	coeff[i]=fact(v/l[i])/coeff[i];    // careful how this stuff evaluates!
      if (i!=0 && 2*i!=v) coeff[i]*=2;
      number+=coeff[i];
    }
  }
  number/=v;
  cout << "Number of isomers = " << number << '\n';
  cout << "Any key to end...\n";
  getch();
	return 0;
}
//---------------------------------------------------------------------------
