//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <conio.h>
#include <fstream.h>
#pragma hdrstop
#include "d:\phd\afmsoft\nrutil.h"
//---------------------------------------------------------------------------
USERES("patgen.res");
USEUNIT("\PhD\AFMsoft\nrutil.cpp");
//---------------------------------------------------------------------------
int main(int argc, char **argv)
{
	bool elim[512];// true to eliminate
  unsigned short pc[512][4];// array to hold pieces
  short npc[512];// no of rotationally different pieces
	bool ptc[512];// piece already used
  for (bool *i=elim; i<elim+512;i++) *i=false;
  for (bool *i=ptc; i<ptc+512;i++) *ptc=false;
  unsigned short tri; // transformed i
  int index=0;// max number of tiles
  //enum etyp {ok,fail,finished};
  //etyp rterror=ok;
  int nx=15,ny=12; // no of pieces in the x and y directions
  int **tile,**tr; //tile index and its rotation
  tile=imatrix(-1,nx-2,-1,ny-2);
  tr=imatrix(-1,nx-2,-1,ny-2);
  for (int i=-1;i<ny-1;i++) {
  	for (int j=-1;j<nx-1;j++) {
    	tile[j][i]=0;tr[j][i]=0;
    }
  }
  nx-=3;ny-=3;
  for (unsigned short i=0; i<512; i++) {
    unsigned short wrap;
    tri=i;
    if (!elim[i]) {
    	pc[index][0]=i;
      npc[index]=0;
  		for (int rot=1;rot<4;rot++) {
    		wrap=tri<<3;
      	wrap&=0x110;
      	wrap|=tri&1;
      	tri>>=1;
      	tri&=0xEE;
      	tri|=wrap;
      	if (tri!=i) {
        	elim[tri]=true;
          pc[index][rot]=tri;
          npc[index]++;
        }
    	}
      npc[index]=(npc[index]==2)?1:npc[index];
    	index++;
    }
  }
  for (int i=0;i<index;i++) {
    for (int j=0;j<=npc[i];j++) {
  		unsigned short b1,b2,b3,b4,b5,b6,b7;
      b1=pc[i][j]&0x100;
      b2=(pc[i][j]<<1)&0x68;
      b3=(pc[i][j]>>5)&4;
      b4=(pc[i][j]>>6)&1;
      b5=(pc[i][j]<<4)&0x10;
      b6=(pc[i][j]<<6)&0x80;
      b7=(pc[i][j]>>2)&2;
      pc[i][j]=b1|b2|b3|b4|b5|b6|b7;
    }
  }

  tile[0][0]=513;tr[0][0]=0; // initialise first piece with dummy value
  unsigned short chkleft,chkup;
	int ax=0,ay=0;//active piece
  	do {
    	if (tile[ax][ay]==513) { // turn dummy tile to real initial tile
      	tile[ax][ay]=0;
        tr[ax][ay]=0;
      }
      else {                 // deal with real tile
      	tr[ax][ay]++;   // try next rotation
        if (tr[ax][ay]>npc[tile[ax][ay]] || ptc[tile[ax][ay]] ) { //if rotation is invalid or tile already used,try next tile
        	tr[ax][ay]=0;
          tile[ax][ay]++;
        }
      }
      // check validity of new tile
      if (tile[ax][ay]==index) { //run out of valid tiles ,so back-space...
      	ax--;
        if (ax<0) {
        	ay--;
          ax=nx;
        }
        ptc[tile[ax][ay]]=false; //free up the piece at that square
        chkleft=pc[tile[ax-1][ay]][tr[ax-1][ay]]&0x3F;
        chkup=pc[tile[ax][ay-1]][tr[ax][ay-1]]&0xDB;
      }
      else if (!ptc[tile[ax][ay]]) { // if piece not already used...
      	bool fit=true;
      	if (ax>0) { // check piece to left
      		unsigned short dummy;
        	dummy=pc[tile[ax][ay]][tr[ax][ay]]>>3;
        	if (dummy!=chkleft) fit=false;
      	}
      	if (ay>0) {//check piece to above
      		unsigned short dummy;
        	dummy=(pc[tile[ax][ay]][tr[ax][ay]]>>1)&0xDB;
        	if (dummy!=chkup) fit=false;
      	}
        if (fit) { //if it fits move on to next piece
          ptc[tile[ax][ay]]=true; //take the current piece first
        	ax++;
          if (ax>nx) {
          	ay++;
            ax=0;
          }
          tile[ax][ay]=513; // nb. no bounds checking. MUST make sure array is too big
 					chkleft=pc[tile[ax-1][ay]][tr[ax-1][ay]]&0x3F;
        	chkup=pc[tile[ax][ay-1]][tr[ax][ay-1]]&0xDB;
        }
      }
    } while (ay>=0 && ay<=ny); //loop if ay still in valid range
  if (ay<0) cout << "No solutions found.\n";
  else {
		ofstream out("patout.txt");
    // output everything at the moment as a test
    for (int i=0; i<ny+1; i++) {
    	for (int j=0; j<nx+1; j++) {
      	float id=256,piece;// output as binary text
        out << pc[tile[j][i]][tr[j][i]] << ' ';
        piece=pc[tile[j][i]][tr[j][i]];
        while (id>=1) {
        	if (piece>=id) {
          	out << '1';
            piece-=id;
          }
          else out << '0';
          id/=2;
        }
        out << ',';
      }
      out << '\n';
    }
    // now try to output formatted pattern
    for (int i=0;i<ny+1;i++) {
    	unsigned short dummy;
    	for (int j=0;j<nx+1;j++) {
      	if (pc[tile[j][i]][tr[j][i]]>255) out << '1';
        else out << '0';
      }
      if ( (pc[tile[nx][i]][tr[nx][i]]) &0x20) out << '1';//output rightmost 2 bits
      else out << '0';
      if ( (pc[tile[nx][i]][tr[nx][i]]) &4) out << "1\n";
      else out << "0\n";
    }
    for (int i=0;i<nx+1;i++) {
    	if ( (pc[tile[i][ny]][tr[i][ny]]) &0x80 ) out << '1';
      else out << '0';
    }
    if ( (pc[tile[nx][ny]][tr[nx][ny]]) &0x10) out << '1';
    else out << '0';
    if ( (pc[tile[nx][ny]][tr[nx][ny]]) &2) out << "1\n";
    else out << "0\n";

    for (int i=0;i<nx+1;i++) {
    	if ( (pc[tile[i][ny]][tr[i][ny]]) &0x40 ) out << '1';
      else out << '0';
    }
    if ( (pc[tile[nx][ny]][tr[nx][ny]]) &8) out << '1';
    else out << '0';
    if ( (pc[tile[nx][ny]][tr[nx][ny]]) &1) out << "1\n";
    else out << "0\n";
    cout << "Completed.\n";
  	out.close();
  }
  free_imatrix(tile,-1,nx+1,-1,ny+1);
  free_imatrix(tr,-1,nx+1,-1,ny+1);
  getch();
	return 0;
}
//---------------------------------------------------------------------------
/*tile[0][0]=0;tr[0][0]=0;      // rubbish code
  bool fitstat=false;
  do {
    do {
  		bool fit=true;
      if (ax>0) {// check piece to left
      	unsigned short dummy;
        dummy=pc[tile[ax][ay],tr[ax][ay]]<<3;
        if (dummy!=pc[tile[ax-1][ay],tr[ax-1][ay]]&0x3F) fit=false;
      }
      if (ay>0) {//check piece to above
      	unsigned short dummy;
        dummy=pc[tile[ax][ay],tr[ax][ay]]>>1&0xDB;
        if (dummy!=pc[tile[ax][ay-1],tr[ax][ay-1]]&0xDB) fit=false;
      }
      if (fit) break;
      else {
      	tr[ax][ay]++;
        if (tr[ax][ay]<npc[tile[ax][ay]]) tr[ax][ay]++;
        else {
        	tr[ax][ay]=0;
          do (tile[ax][ay]++;) while (tile[ax][ay]<index&&ptc[tile[ax][ay]]=false);
        }
      }
    } while (tile[ax][ay]<index);
    if (tile[ax][ay]==index) {
    //insert code for backspace
    }
    else {
    //insert code for take piece and forward space
    }
  } // check for end of board...etc


  } */
